function r=uladata(theta,S,N,sig2,m,delta)
%
%    theta  <- angoli di arrivo delle m sorgenti in gradi
%    S      <- Matrice di covarianza dei segnali sorgente diagonale per
%              l'ipotesi di segnali sorgente scorrelati
%    N      <- numero di istanti da generare
%    sig2   <- varianza del rumore
%    m      <- numero di sensori
%    delta  <- spaziatura fra i sensori in lunghezze d'onda
%    r      -> m x N matrice di dati r = [r(1),...,r(N)]

% generazione della matrice A
A=exp(-2*pi*j*delta*[0:m-1].'*sin([theta(:).']*pi/180));

% generazione dei segnali sorgente
n=max(size(S));%ottengo il numero di segnali sorgente
s=(sqrtm(S)')*randn(n,N);      % s(t)

% ganerazione della componente di rumore
e=sqrt(sig2/2)*(randn(m,N)+j*randn(m,N));

% dati dall'ULA(Array lineare uniforme)
r=A*s+e;
