function [PSSP,x]=modified_eigenstructure(signal,d,f_centrale,var_fase)
%
% Metodo MUSIC modificato (Paulraj-Kailath)
% per la stima della direzione di arrivo in situazione di
% parziale coerenza spaziale 
%
%      var_fase    <- varianza dell'incremento di fase da sensore a sensore
%      signal      <- dati dell'array lineare uniforme
%      d           <- numero delle sorgenti
%      
%      plot Pseudospettro

[m,N]=size(signal);

% calcolo della matrice di covarianza campionata
R=signal*signal'/N;

B=B_matrix(m,var_fase);

P=B.*R;
C=1./B;

SH=C.*P;
delta=spaziatura(f_centrale);
passo=0.2;
c=3e8;
naz=round(180/passo);

% calcolo autovettori e autovalori di SH
[U,D,V]=svd(SH);


for ia=1:naz

Az=(ia-1-naz/2)*passo;

psi=[0:m-1]*2*pi*f_centrale*(delta/c)*sin(pi*Az/180);

a_theta=exp(-j*psi');

%calcolo della potenza del pseudo-spettro

sum=0;

for k=d+1:m
sum=sum+(abs(a_theta'*U(:,k)))^2;
end

Pseudospettro(ia)=1/sum;

end
PSSP=10*log10(Pseudospettro);
x=([1:naz]-1-naz/2)*passo;


plot(x,PSSP);
title('Metodo di Paulraj e Kailath(stima esatta)');

xlabel('Angoli di incidenza in gradi')

ylabel('Pseudospettro MUSIC(dB)') 
